#ifndef ENVIRONMENT_H
#define ENVIRONMENT_H

#include "object.h"

struct Environment;
struct Environment {
    char** strings;
    Object* objects;
    struct Environment* outer;
    int size;

    int structCount;
    int structCapacity;
    struct StructDef* structDefs;

    int refs;
    const char* name;
};

struct Environment* global();

void setGlobal(struct Environment* env);

Object fetchFromEnvironment(const char* name, struct Environment* env);

struct Environment envForLambda(const Object* params, const Object* arg_forms,
                                struct Environment* outer);

void addToEnv(struct Environment* env, const char* name, Object obj);

void printEnv(struct Environment* env);

void addFunc(const char* name,
             Object (* func)(Object*, int, struct Environment*),
             struct Environment* env);

void deleteEnv(struct Environment* e);

struct Environment defaultEnv();

struct StructDef getStructDef(struct Environment* env, const char* name);

int getStructIndex(struct Environment* env, const char* name);

/// Needs to be freed!
char* getHelp(const char* symbol);

int runTests();

#endif
